/*********************************************/
/*  player.c  test player strat routine      */
/*********************************************/



#include <AGB.h>
#include "asldefines.h"
//#include "data.h"
#include "player.h"
#include "Rocksandstuff.h"
#include "rocks.h"
#include "shrapnel.h"
#include "main.h"
#include "switch.h"
#include "camera.h"
#include "Samplemanager.h"
#include "lewahiobjects.h"
#include "kowahiobjects.h"
#include "tawahiobjects.h"
#include "powahiobjects.h"
#include "gawahiobjects.h"
#include "onuwahiobjects.h"
#include "Chain.h"
#include "SampleManager.h"
#include "Shadow.h"

rockparms rock[16];
dropperparms dropper[16];
rubbleparms rubble[16];
u8 rockclock;
u8 lastrock;

u8 rockfalltime;
s16 rockfallx;
s16 rockfallwidth;

const u32 RockSpr[6] = {(u32)KoWahiPlatformSprite + 4096,(u32)PoWahiPlatformSprite + 4096,(u32)TaWahiPlatformSprite + 4096,
						(u32)KoWahiPlatformSprite + 4096,(u32)PoWahiPlatformSprite + 4096,(u32)PoWahiPlatformSprite + 4096};

const u32 DropSpr[6] = {(u32)KoWahiDropperSprite,(u32)PoWahiDropperSprite,(u32)TaWahiDropperSprite,
						(u32)KoWahiDropperSprite,(u32)KoWahiDropperSprite,(u32)PoWahiDropperSprite};

						
const u32 RockPal[6] = {(u32)KoWahiPlatformPalette,(u32)PoWahiPlatformPalette,(u32)TaWahiPlatformPalette,
						(u32)KoWahiPlatformPalette,(u32)KoWahiPlatformPalette,(u32)PoWahiPlatformPalette};

const u32 DropPal[6] = {(u32)KoWahiPlatformPalette,(u32)PoWahiPlatformPalette,(u32)TaWahiPlatformPalette,
						(u32)KoWahiPlatformPalette,(u32)KoWahiPlatformPalette,(u32)PoWahiPlatformPalette};

extern s16 game_x;
extern s16 game_y;

u8 NextRock(void)
{
	u8 a;
	for(a = 0; a < 16; a++)
	{
		if(rock[a].xpos == 0)
		{
			rock[a].xpos = 1;
			return a;
		}
	}
	return 0;
}

void RemoveRock(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	rock[me].xpos = 0;
}

void initrock(void)
{
	u32 i;
	u8 me;
	
	me = NextRock();
	//rock[me].frame = GrabASprite();
	Object[num_strats].handle = HandleRock;
	Object[num_strats].remover = RemoveRock;
//	i = rock[me].frame;
    rock[me].xpos = parm_xpos;
    rock[me].ypos = parm_ypos; 
    rock[me].dy = 0;
    rock[me].patrollx = parm_xpos;
    rock[me].patrolrx = wp_xpos; //Object[num_strats].parameter;
 	rock[me].dx = 1;
 	rock[me].startx = parm_xpos;
 	rock[me].starty = parm_ypos;
 	
 	rock[me].mytrigger = Object[num_strats].parameter / 100;
 	rock[me].mode = Object[num_strats].parameter % 100;
 	rockclock = 0;
	Object[num_strats].parameter = me;
//	LoadPalette(RockPalette,3);
//	EnemySprite[nxtenemy] = ENEMY_ROCK;
//	LoadSprite((u32)RockSprite + 4096 ,EnemySpriteOffset[nxtenemy], 2048);

}

void HandleRock(void)
{
	u8 me;
	s16 sprx,spry;
	u32 sprite_ptr;
	s16 ground;
	u8 trigger;
	u8 spd;
	
	me = Object[current_strat].parameter;
	if(me  <= lastrock) // first rock strat this frame ? if so, update rotations
	{
		rockclock+=8;
//		SpriteRotate(1,rockclock);
//		SpriteRotate(2,255 - rockclock);
	}
	lastrock = me;



	trigger = 0;
	spd = 1;
	if(rock[me].mytrigger > 98)
		trigger = 1;
	else
		if(tswitch[rock[me].mytrigger].state)
		{
			trigger = 1;
			
			if(lastcamera == rock[me].mytrigger)
			{
				camera_followx = rock[me].xpos;
				camera_followy = rock[me].ypos;
				spd = 2;
			}
		}	

//	mysprite = rock[me].frame;
	if(trigger == 1)
	{
		rock[me].xpos += rock[me].dx * spd;
		if((GameClock & 3) == 0 && Game_Area != 1) // no smoke from snowballs ;)
			 spawnparticle(rock[me].xpos - 16,rock[me].ypos + 16 ,0,0,-rock[me].dx * spd,-2,16,50,0);
		
		ground = ForceOtherCollision(rock[me].xpos,rock[me].ypos);
		if(rock[me].ypos < ground - 8) // fall
		{
			rock[me].dy = min(4,rock[me].dy + 1);
			rock[me].ypos += rock[me].dy;
			if(rock[me].ypos > 2048)
			{
				rock[me].xpos = rock[me].startx;
				rock[me].ypos = rock[me].starty;
			}
		}
		else
		{
			rock[me].ypos = ground;
			rock[me].dy = 0;
		}
		
		if(rock[me].xpos >= rock[me].patrolrx)
		{
			rock[me].dx = -1;
			if(rock[me].mode != 99)
			{
				rock[me].dx = 0;
				if(rock[me].mode < 99) // switch
				{
					tswitch[rock[me].mode].state = 1; // throw it
				//	Sprite[mysprite].VPos = 161;
				//	Sprite[mysprite].AffineMode = 0;
					remove();						
					//remove();
					// possibly add particle scatter here.
				}
			}
		}	
		if(rock[me].xpos <= rock[me].patrollx)
			rock[me].dx = 1;

		CameraPush = smin(CameraPush + smin(rock[me].xpos - player.xpos,4),64);
	
			
	}
	// AI
	
	// wait until triggered
	// trigger on switch, or when player is within patrol range
	
	// when triggered
	// roll in dx, reverse on hitting patrol range
	// stick to floor, fall to next floor level when there's no floor	

	// if fall off map, respawn to top	

	sprx = rock[me].xpos - game_x - 64; //. scaled sprite, so now another 32 pixels wide
	spry = rock[me].ypos - game_y  - 64;
	if(sprx >= -64 && sprx < 240 && spry >= -64 && spry < 160 && trigger == 1)
	{
		mysprite = NextSprite++;
    	Sprite[mysprite] = *(OamData *)OamData_Sample;
		
	Sprite[mysprite].Size = RockSizeShape[0];
	Sprite[mysprite].Shape = RockSizeShape[1];
    Sprite[mysprite].Priority = 2;
   Sprite[mysprite].AffineMode = 3; // 0 off 3 on and double size
    Sprite[mysprite].AffineParamNo_L = 1; // use affine 1 (roll left) and 2 (roll right)
	

		if(player_state != player_state_attack)
		{
			if((abs(player.xpos - rock[me].xpos) < 48) && (abs(player.ypos - rock[me].ypos) < 48))
			{
				HitPlayer(1);
			}
		}

	//	if(EnemySprite[nxtenemy] != ENEMY_ROCK)
	//	{
			LoadEnemyPalette(RockPal[Game_Area],nxtenemypal);
	   		Sprite[mysprite].Pltt = 2 + PalCache;

		//	EnemySprite[nxtenemy] = ENEMY_ROCK;
			sprite_ptr = (u32)RockSpr[Game_Area];
			LoadEnemySprite(sprite_ptr, 2048);
	//	}
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
		
  		Sprite[mysprite].AffineMode = 3; // 0 off 3 on and double size
		Sprite[mysprite].HFlip = 0;
		if(rock[me].dx > 0)
   		{
   			 Sprite[mysprite].AffineParamNo_L = 1; // use affine 1 (roll left) and 2 (roll right)
			SpriteRotate(1,rotateclock);
		}
		else
   		{
   			 Sprite[mysprite].AffineParamNo_L = 2; // use affine 1 (roll left) and 2 (roll right)
			SpriteRotate(1,rotateclock);
		}
	}
	else
	{
//		Sprite[mysprite].VPos = 160;
 //  Sprite[mysprite].AffineMode = 0; // 0 off 3 on and double size
	//	SpriteScale(1,1,1);
	}

}


void initswingingrock(void)
{
	u32 i;
	u8 me;
	
	me = NextRock();
	//rock[me].frame = GrabASprite();
	Object[num_strats].handle = HandleSwingingRock;
	Object[num_strats].remover = RemoveRock;
//	i = rock[me].frame;
    rock[me].xpos = parm_xpos;
    rock[me].ypos = parm_ypos; 
    rock[me].patrollx = 0; // angle
    rock[me].patrolrx = (parm_ypos - wp_ypos);
 	rock[me].dx = 4;
 	rock[me].dy = max(1,min(8,(parm_ypos - wp_ypos) / 14)); // number of chain links
 	
 	rock[me].startx = wp_xpos;
 	rock[me].starty = wp_ypos;
  	rockclock = 0;
	Object[num_strats].parameter = me;

}

void HandleSwingingRock(void)
{
	u8 me;
	s16 sprx,spry;
	u32 sprite_ptr;
	s16 ground;
	u8 trigger;
	u8 spd;
	s16 dx,dy;
	u8 a;
	s16 distance;
	
	me = Object[current_strat].parameter;
	if(me  <= lastrock) // first rock strat this frame ? if so, update rotations
	{
		rockclock+=8;
//		SpriteRotate(1,rockclock);
//		SpriteRotate(2,255 - rockclock);
	}
	lastrock = me;

	rock[me].xpos = rock[me].startx + ((fsin[((rock[me].patrollx >> 2) + 128) & 255] * rock[me].patrolrx) >> 8);
	rock[me].ypos = rock[me].starty + ((fsin[((rock[me].patrollx >> 2) + 64) & 255] * rock[me].patrolrx) >> 8);
	
	rock[me].patrollx += rock[me].dx;
	if((GameClock & 3) == 0)
	{
		// Trigger a whoosh sound when the rock chanegs direction at velocity == 0
		if(rock[me].patrollx < -160 || rock[me].patrollx > 160)
		{
			if (rock[me].dx == 0)
			{
				 distance = rock[me].xpos - (game_x + 120);
				if (distance < 0)
				{
					distance = -distance;
				}
				if (distance < 600)
				{
					Sample_PlayVolume(SMPL_SWINGING_BOULDER01,256 - ((64 * distance) / 600));
				}
			}
		}
		else
		{
			if(rock[me].dx == 0)
				rock[me].dx = 4;	
		}

		if(rock[me].patrollx < -160)
		{
			rock[me].dx = min(4,rock[me].dx + 1);
		}
		if(rock[me].patrollx > 160)
		{
			rock[me].dx = max(-4,rock[me].dx - 1);
		}
	}
	sprx = rock[me].xpos - game_x - 32; //. scaled sprite, so now another 32 pixels wide
	spry = rock[me].ypos - game_y  - 32;
	if(sprx >= -64 && sprx < 240 && spry >= -64 && spry < 160)
	{
		mysprite = NextSprite++;
    	Sprite[mysprite] = *(OamData *)OamData_Sample;
		
		Sprite[mysprite].Size = RockSizeShape[0];
		Sprite[mysprite].Shape = RockSizeShape[1];
	    Sprite[mysprite].Priority = 2;
	   Sprite[mysprite].AffineMode = 0; // 0 off 3 on and double size
	    Sprite[mysprite].AffineParamNo_L = 0; // use affine 1 (roll left) and 2 (roll right)
	

		if(player_state != player_state_attack)
		{
			if((abs(player.xpos - rock[me].xpos) < 48) && (abs(player.ypos - rock[me].ypos) < 48))
			{
				HitPlayer(1);
			}
		}

		LoadEnemyPalette(TaWahiPlatformPalette,nxtenemypal);
   		Sprite[mysprite].Pltt = 2 + PalCache;

		sprite_ptr = (u32)TaWahiPlatformSprite + 4096;
		LoadEnemySprite(sprite_ptr, 2048);
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;

		// draw the chain
	 	dx = (rock[me].startx - rock[me].xpos);
	 	dy = (rock[me].starty - rock[me].ypos  + 32);
	 	
	 	dx /= rock[me].dy;
	 	dy /= rock[me].dy;
	 	sprx += 24;
		spry -= 8;
	 	 
	 	sprite_ptr = (u32)ChainSprite;
	 	LoadEnemyPalette(ChainPalette,nxtenemypal);
	 	LoadEnemySprite(sprite_ptr,128); 
	 	for(a = 0; a < rock[me].dy; a++) // draw chain links
	 	{
			if(sprx >= -64 && sprx < 240 && spry >= -64 && spry < 160)
			{
	 			mysprite = NextSprite++;
	  			Sprite[mysprite] = *(OamData *)OamData_Sample;
	 			Sprite[mysprite].Size = 1; // 16 * 16
	 			Sprite[mysprite].Shape = 0;
	 			Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
	 			Sprite[mysprite].Pltt = 2 + PalCache;
	 			Sprite[mysprite].VPos = (spry + 256) & 255;
	 			Sprite[mysprite].HPos = sprx & 511;
	 			
	 			
	 		}
	 		sprx += dx;
	 		spry += dy;
	 	}		
 	}
 	

}


/** Dropper (Stalactites, rocks etc.)

*/

u8 NextDropper(void)
{
	u8 a;
	for(a = 0; a < 16; a++)
	{
		if(dropper[a].xpos == 0)
		{
			dropper[a].xpos = 1;
			return a;
		}
	}
	return 0;
}

void RemoveDropper(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	dropper[me].xpos = 0;
}

void initdropper(void)
{
	u8 me;
	u8 i;
	u8 parm;
	
	me = NextDropper();
//	dropper[me].frame = GrabASprite();
	Object[num_strats].handle = HandleDropper;
	Object[num_strats].remover = RemoveDropper;
//	i = dropper[me].frame;
// 	Sprite[i].CharNo = EnemySprite[nxtenemy];
	dropper[me].xpos = parm_xpos;
	dropper[me].ypos = parm_ypos;
	dropper[me].mytrigger = 0;
	parm = Object[num_strats].parameter % 10;
	
	if(parm == 1) // override trigger
		dropper[me].mytrigger = 1;
	dropper[me].trigx = wp_xpos;
	dropper[me].trigy = wp_ypos;
	dropper[me].dy = 0;
	dropper[me].delay = ( Object[num_strats].parameter / 10) * 15;
	
	Object[num_strats].parameter = me;

}

void HandleDropper(void)
{
	u8 me,mysprite;
	s16 ground;
	s16 sprx,spry;
	u32 sprite_ptr;
	
	me = Object[current_strat].parameter;
	
	if(dropper[me].mytrigger)
	{
		if(dropper[me].delay > 0)
		{
			dropper[me].delay--;
		}
		else
		{
			dropper[me].ypos += (dropper[me].dy >> 2);
			dropper[me].dy = min(16,dropper[me].dy+1);
			if(dropper[me].dy == 8)
				Sample_Play(SMPL_STALAGNITE_FALL);
			ground = ForceOtherCollision(dropper[me].xpos,dropper[me].ypos);
			if(dropper[me].ypos >= ground)
			{
				//Sprite[mysprite].VPos = 161;
				spawn(initrubble,dropper[me].xpos,dropper[me].ypos, 0);

				respawnme();
				remove();
			}
		}
	}
	else
	{
		if(abs(player.xpos - dropper[me].trigx) < 64 && abs(player.ypos - dropper[me].trigy) < 64)
		{
			dropper[me].mytrigger = 1;
			Sample_Play(SMPL_STALAGNITE_CRACK);
			CameraShake = 5;
		}
	
	}
	sprx = dropper[me].xpos - game_x - 32;
	spry = dropper[me].ypos - game_y;
		
	//mysprite = dropper[me].frame;

	if(sprx > -32 && sprx < 240 && spry > -32 && spry < 160)
	{
	//	if(EnemySprite[nxtenemy] != ENEMY_DROPPER)
	//	{
		mysprite = NextSprite++;
    	Sprite[mysprite] = *(OamData *)OamData_Sample;
		
		Sprite[mysprite].ObjMode = 0; // trans effect
	    Sprite[mysprite].AffineMode = 0; // off 
	    Sprite[mysprite].AffineParamNo_L = 0; // use affine 0
		Sprite[mysprite].Size = 2;
		Sprite[mysprite].Shape = 0;
    	Sprite[mysprite].Priority = 2;

			if(player_state != player_state_attack)
			{
				if((abs(player.xpos - dropper[me].xpos) < 16) && (abs(player.ypos - dropper[me].ypos) < 16))
				{
					HitPlayer(1);
				}
			}

			LoadEnemyPalette(DropPal[Game_Area],nxtenemypal);
	   		Sprite[mysprite].Pltt = 2 + PalCache;

	//		EnemySprite[nxtenemy] = ENEMY_DROPPER;
			sprite_ptr = (u32)DropSpr[Game_Area];
			LoadEnemySprite(sprite_ptr, 512);
	//	}
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
	}
	
	sprx = dropper[me].xpos - game_x - 32;
	spry = dropper[me].ypos + 32;
	spry = ForceOtherCollision(dropper[me].xpos,spry) - game_y;
	
	if(sprx > -32 && sprx < 240 && spry > -32 && spry < 160 && ((GameClock & 1) == 0))
	{
	//	if(EnemySprite[nxtenemy] != ENEMY_DROPPER)
	//	{
		mysprite = NextSprite++;
		
		Sprite[mysprite] = *(OamData *)OamData_Sample;
	    Sprite[mysprite].Priority = 2;
 	  	Sprite[mysprite].ObjMode =0; // obj transparency mode
   	 	Sprite[mysprite].Pltt = 0;
    	Sprite[mysprite].Shape = ShadowSizeShape[1];
    	Sprite[mysprite].Size = ShadowSizeShape[0];

		Sprite[mysprite].CharNo = SHADOW_SPRITE;
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
	}	
	

	
}

/** Rubble (bits of rock blasting about etc.)

*/

u8 NextRubble(void)
{
	u8 a;
	for(a = 0; a < 16; a++)
	{
		if(rubble[a].xpos == 0)
		{
			rubble[a].xpos = 1;
			return a;
		}
	}
	return 0;
}

void RemoveRubble(void)
{

	u8 me;
	me = Object[current_strat].parameter;
	rubble[me].xpos = 0;
}

void initrubble(void)
{
	u8 me;
	u8 i;
	
	me = NextRubble();
//	rubble[me].frame = GrabASprite();
	Object[num_strats].handle = HandleRubble;
	Object[num_strats].remover = RemoveRubble;
//	i = rubble[me].frame;
	rubble[me].xpos = parm_xpos;
	rubble[me].ypos = parm_ypos;
	rubble[me].dy = srnd(4) - 12;
	rubble[me].dx = srnd(12);
	Object[num_strats].parameter = me;

}


void initrubblefall(void)
{
	u8 me;
	u8 i;
	
	me = NextRubble();
//	rubble[me].frame = GrabASprite();
	Object[num_strats].handle = HandleRubble2;
	Object[num_strats].remover = RemoveRubble;
//	i = rubble[me].frame;
	rubble[me].xpos = parm_xpos;
	rubble[me].ypos = parm_ypos;
	rubble[me].dy = 0;
	rubble[me].dx = srnd(6);
	Object[num_strats].parameter = me;

}

void HandleRubble(void)
{
	u8 me,mysprite;
	s16 ground;
	s16 sprx,spry;
	u32 sprite_ptr;
	
	me = Object[current_strat].parameter;
	
	rubble[me].ypos += (rubble[me].dy >> 2);
	rubble[me].dy = min(16,rubble[me].dy+1);
	rubble[me].xpos += (rubble[me].dx >> 2);
	ground = ForceOtherCollision(rubble[me].xpos,rubble[me].ypos);
	if(rubble[me].ypos >= ground || rubble[me].ypos > PlayerMapHeight * 8)
	{
		rubble[me].dy = -(rubble[me].dy / 2);
		if(rubble[me].dy > -8 || (rubble[me].ypos > PlayerMapHeight * 8))
		{
		//	Sprite[rubble[me].frame].VPos = 161;
			remove();
			return;
		}
		rubble[me].ypos = ground - 1;

		
	}
	sprx = rubble[me].xpos - game_x - 32;
	spry = rubble[me].ypos - game_y;
		

	if(sprx > -32 && sprx < 240 && spry > -32 && spry < 160)
	{
		mysprite = NextSprite++;
    	Sprite[mysprite] = *(OamData *)OamData_Sample;
		
		Sprite[mysprite].ObjMode = 0; // trans effect
	    Sprite[mysprite].AffineMode = 0; // off 
	    Sprite[mysprite].AffineParamNo_L = 0; // use affine 0
	 	Sprite[mysprite].CharNo = EnemySprite[nxtenemy];
		Sprite[mysprite].Size = ShrapnelSizeShape[0];
		Sprite[mysprite].Shape = ShrapnelSizeShape[1];
  		 Sprite[mysprite].Priority = 2;

	//	if(EnemySprite[nxtenemy] != ENEMY_DROPPER)
	//	{
			LoadEnemyPalette(ShrapnelPalette,nxtenemypal);
	   		Sprite[mysprite].Pltt = 2 + PalCache;

	//		EnemySprite[nxtenemy] = ENEMY_DROPPER;
			sprite_ptr = (u32)ShrapnelSprite; 
			LoadEnemySprite(sprite_ptr, 128);
	//	}
	
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
	}
	else
	{
		//Sprite[mysprite].VPos = 160;
	}

	
}

void HandleRubble2(void)
{
	u8 me,mysprite;
	s16 sprx,spry;
	u32 sprite_ptr;
	
	me = Object[current_strat].parameter;
	
	rubble[me].ypos += (rubble[me].dy >> 2);
	rubble[me].dy = min(16,rubble[me].dy+1);
	rubble[me].xpos += (rubble[me].dx >> 2);
	if(rubble[me].ypos >= (PlayerMapHeight << 3))
	{
		remove();
		return;
	}
	sprx = rubble[me].xpos - game_x - 32;
	spry = rubble[me].ypos - game_y;
		

	if(sprx > -32 && sprx < 240 && spry > -32 && spry < 160)
	{
		mysprite = NextSprite++;
    	Sprite[mysprite] = *(OamData *)OamData_Sample;
		
		Sprite[mysprite].ObjMode = 0; // trans effect
	    Sprite[mysprite].AffineMode = 0; // off 
	    Sprite[mysprite].AffineParamNo_L = 0; // use affine 0
	 	Sprite[mysprite].CharNo = EnemySprite[nxtenemy];
		Sprite[mysprite].Size = ShrapnelSizeShape[0];
		Sprite[mysprite].Shape = ShrapnelSizeShape[1];
  		 Sprite[mysprite].Priority = 2;

	//	if(EnemySprite[nxtenemy] != ENEMY_DROPPER)
	//	{
			LoadEnemyPalette(ShrapnelPalette,nxtenemypal);
	   		Sprite[mysprite].Pltt = 2 + PalCache;

	//		EnemySprite[nxtenemy] = ENEMY_DROPPER;
			sprite_ptr = (u32)ShrapnelSprite; 
			LoadEnemySprite(sprite_ptr, 128);
	//	}
	
		Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
		Sprite[mysprite].HPos = sprx & 511;
		Sprite[mysprite].VPos = (spry + 256) & 255;
	}

	
}



void initrockfall(void)
{
	u32 i;
	u8 me;
	u8 a;
	
	
	//rock[me].frame = GrabASprite();
	Object[num_strats].handle = HandleRockfall;
	Object[num_strats].remover = 0;
	rockfalltime = 180; // 3 secs
	rockfallx = parm_xpos;
	rockfallwidth = wp_xpos - parm_xpos;
	
	for(a = 0; a < 16; a++)
	{
		dropper[a].xpos = rockfallx + rnd(rockfallwidth);
		dropper[a].ypos = game_y - rnd(64);
		dropper[a].dy = 4 + rnd(4); 
	}

	Freeze_Player = 2; // maybe make player duck here
	

}


void HandleRockfall(void)
{
	u8 a,b,mysprite;
	s16 sprx,spry;
	u32 sprite_ptr;
	
	CameraPush = 0;
	rockfalltime--;
	if(rockfalltime > 63)
	{
		LoadEnemyPalette(RockPal[Game_Area],nxtenemypal);
		sprite_ptr = (u32)RockSpr[Game_Area];
		LoadEnemySprite(sprite_ptr, 2048);
		SpriteRotate(1,rotateclock);
		for(a = 0; a < 8;a++)
		{
			sprx = dropper[a].xpos - game_x - 32; //. scaled sprite, so now another 32 pixels wide
			spry = dropper[a].ypos - game_y  - 32;
			if(sprx >= -64 && sprx < 240 && spry >= -64 && spry < 160 )
			{
				mysprite = NextSprite++;
	    	Sprite[mysprite] = *(OamData *)OamData_Sample;
			
				Sprite[mysprite].Size = RockSizeShape[0];
				Sprite[mysprite].Shape = RockSizeShape[1];
			    Sprite[mysprite].Priority = 0;
			   	Sprite[mysprite].AffineMode = 0; // 0 off 3 on and double size
			   
			   	if((a & 3) == 0) // every 4th one rotates
			   	{
			    	Sprite[mysprite].AffineParamNo_L = 1; // use affine 1 (roll left) and 2 (roll right)
					Sprite[mysprite].AffineMode = 1;
				}
				Sprite[mysprite].Pltt = 2 + PalCache;
				Sprite[mysprite].CharNo = EnemySprite[SpriteCache];
				Sprite[mysprite].HPos = sprx & 511;
				Sprite[mysprite].VPos = (spry + 256) & 255;
				
			}	
			dropper[a].ypos += dropper[a].dy;
			if(dropper[a].ypos>= player.ypos - 32) // hit ground
			{
				if(a & 4)
					Sample_Play(SMPL_WALL_SMASH01);
				for(b = 0; b < 4 ;b ++)
				{
					spawn(initrubble,dropper[a].xpos + srnd(32),dropper[a].ypos + srnd(32),0);
				}
				dropper[a].xpos = rockfallx + rnd(rockfallwidth);
				dropper[a].ypos = game_y - rnd(64);
				dropper[a].dy = 4 + rnd(4); 
			
			}
		}
	}
	else
	{
		if(rockfalltime == 0)
		{
			BlendUp(0);
			Freeze_Player = 0;
			remove();
		}
		else
		{
			if(rockfalltime > 31)
			{
				BlendUp(31 - rockfalltime / 2);
				if(rockfalltime == 32) // swap tiles now
				{
					tswitch[4 + BaragTwin].state = 1;
				}
			}
			else
			{
				BlendUp(rockfalltime / 2);
			}
		}
	}
}