// Spritelist.h



// VRAM sizes of sprite

#define  PLAYER_SPRITE_SIZE	2048
#define  PLAYER2_SPRITE_SIZE	2048
#define  ENEMY_SPRITE_SIZE	2048
#define  BOHROK_SPRITE_SIZE	2048
#define  BOSS_SPRITE1_SIZE	2048
#define  PARTICLE_SPRITE_SIZE	32
#define  SHADOW_SPRITE_SIZE	1024
#define  FRISBEE_SPRITE_SIZE	256
#define  AMMO_SPRITE_SIZE	128
#define  SWITCH_SPRITE_SIZE	512
#define  PLATFORM_SPRITE_SIZE	2048
#define  BOSS_SPRITE2_SIZE	512
#define  DOOR_SPRITE_SIZE	1024
#define  PUP_HEALTH_SPRITE_SIZE	512
#define  PUP_EPOWER_SPRITE_SIZE	512
#define  PUP_LIFE_SPRITE_SIZE	512
#define  PUP_DISC_SPRITE_SIZE	512
#define  FONT_SPRITE_SIZE	32
#define  PICKUP_SPRITE_SIZE	128
#define  FLASH_SPRITE_SIZE	2048
#define  PANEL_SPRITE1_SIZE	512
#define  SMOKE_SPRITE_SIZE	512
#define  END_SPRITE_SIZE	0

#define  BUTTON_MSPRITE_SIZE	512
#define  BIGBUTTON_MSPRITE_SIZE	512
#define  BIGTEXT_MSPRITE_SIZE	128
#define  MASK_MSPRITE_SIZE	2048
#define  BIGICON_MSPRITE_SIZE	1024

// VRAM character numbers of sprite

#define  PLAYER_SPRITE	0
#define  PLAYER2_SPRITE	64
#define  ENEMY_SPRITE	128
#define  BOHROK_SPRITE	192
#define  BOSS_SPRITE1	256
#define  PARTICLE_SPRITE	512
#define  SHADOW_SPRITE	560
#define  FRISBEE_SPRITE	592
#define  AMMO_SPRITE	600
#define  SWITCH_SPRITE	604
#define  PLATFORM_SPRITE	620
#define  BOSS_SPRITE2	748
#define  DOOR_SPRITE	764
#define  PUP_HEALTH_SPRITE	796
#define  PUP_EPOWER_SPRITE	812
#define  PUP_LIFE_SPRITE	828
#define  PUP_DISC_SPRITE	844
#define  FONT_SPRITE	860
#define  PICKUP_SPRITE	861
#define  FLASH_SPRITE	869
#define  PANEL_SPRITE1	933
#define  SMOKE_SPRITE	949
#define  END_SPRITE	1013

#define  BUTTON_MSPRITE	0
#define  BIGBUTTON_MSPRITE	16
#define  BIGTEXT_MSPRITE	32
#define  MASK_MSPRITE	304
#define  BIGICON_MSPRITE	688

#define  PLAYER_SPRITE_OFFSET	0
#define  PLAYER2_SPRITE_OFFSET	2048
#define  ENEMY_SPRITE_OFFSET	4096
#define  BOHROK_SPRITE_OFFSET	6144
#define  BOSS_SPRITE1_OFFSET	8192
#define  PARTICLE_SPRITE_OFFSET	16384
#define  SHADOW_SPRITE_OFFSET	17920
#define  FRISBEE_SPRITE_OFFSET	18944
#define  AMMO_SPRITE_OFFSET	19200
#define  SWITCH_SPRITE_OFFSET	19328
#define  PLATFORM_SPRITE_OFFSET	19840
#define  BOSS_SPRITE2_OFFSET	23936
#define  DOOR_SPRITE_OFFSET	24448
#define  PUP_HEALTH_SPRITE_OFFSET	25472
#define  PUP_EPOWER_SPRITE_OFFSET	25984
#define  PUP_LIFE_SPRITE_OFFSET	26496
#define  PUP_DISC_SPRITE_OFFSET	27008
#define  FONT_SPRITE_OFFSET	27520
#define  PICKUP_SPRITE_OFFSET	27552
#define  FLASH_SPRITE_OFFSET	27808
#define  PANEL_SPRITE1_OFFSET	29856
#define  SMOKE_SPRITE_OFFSET	30368
#define  END_SPRITE_OFFSET	32416

#define  BUTTON_MSPRITE_OFFSET	0
#define  BIGBUTTON_MSPRITE_OFFSET	512
#define  BIGTEXT_MSPRITE_OFFSET	1024
#define  MASK_MSPRITE_OFFSET	9728
#define  BIGICON_MSPRITE_OFFSET	22016

/* Sprite Palette allocation...

palette		Sprites

0			Player character 1 (current player char)
1			Player character 2 (swap character)

2			Enemy Pal 1			+ boss palette 0	+ Mask pal 0
3			Enemy Pal 2			+ boss palette 1	+ Mask pal 1
4			Enemy Pal 3								+ Mask pal 2
5			Enemy Pal 4			+ boss palette 2	+ Mask pal 3
6													+ Mask pal 4
7			Disc palette										+ Mask pal 5
8			Platforms+ doors								+ Mask Shadow pal
9			switches
10			Pickups 1           Life + Health + elemental
11			Level specific pickups
12			Font	(sprite version)

13			FX ( trails etc.)
14			Panels 
15			Particles + Dyson of Death
*/

