// Text routines.

// text is done as a 'map' on a front screen, overlaying all the others

#include <AGB.H>
#include <string.h>
#include <stdlib.h>
#include "asldefines.h"
#include "data.h"
#include "font.h"
#include "main.h"

u8 TextCol;

void TextOn(void)
{

   *(vu16 *)REG_BG3CNT =                             // Set BG control for BG 1
            BG_COLOR_16 | BG_SCREEN_SIZE_0 | BG_PRIORITY_0
            | 5 << BG_SCREEN_BASE_SHIFT | 3 << BG_CHAR_BASE_SHIFT ;
    *(vu16 *)REG_DISPCNT = |= DISP_BG3_ON; // screen 3 on

}

void TextOff(void)
{
    *(vu16 *)REG_DISPCNT = &= (~DISP_BG3_ON); // screen 3 off

}

void TextClear(void)
{
	u32 * dest;
	dest = (u32 *)( BG_VRAM + 5 * 2048);
	
	DmaClear(dest, 0,32 *20,32);
}

void Text(u8 x,u8 y,char * string)
{
	u8 a,b,n;
	u32 * dest;
	
	x >>= 3;
	y >>= 3;
	dest = (u32 *)( BG_VRAM + 5 * 2048);

	n = 0;
	for(a = 0 ; a < strlen(string);a++)
	{
		
		*(dest + x + a + (y * 32)) = string[a] + 256 + (15 << 12);
	}

}

void TextColour(u8 red, u8 green, u8 blue)
{
	u16 bgr;
	u16 * ptr;
	
	
	TextCol = col;
}
