// text.h
#ifndef TEXT_H
#define TEXT_H

#define MAX_BIGCHARS	64

typedef struct {
	s16 xpos;
	s16 ypos;
} bigstringparms;

typedef struct {
	u8 xpos;
	s8 ypos;
	u8 character;
	u8 active;
} bigcharparms;

bigstringparms BigString[12];
u8 TextAutoCentre;

void TextOn(void);
void TextOff(void);
void TextClear(void);
void TextCentre(s8 x,u8 y,char * string);
void Text(u8 x,u8 y,char * string);
void TextColour(u8 red,u8 green,u8 blue);
void TextColour2(u8 red, u8 green,u8 blue);

void BigText(u8 textnum, s16 xpos,s16 ypos,char * string);
void BigTextMove(u8 textnum, s16 xpos,s16 ypos);
void BigTextRemove(u8 textnum);
u8 BigTextLen(char * string);
u8  NextBigChar(void);
void initbigchar(void);
void HandleBigChar(void);
void HandleBigIcon(void);
void initbigicon(void);

void KillBigChars(void);

#endif
