//======================================================
//	menuitem.h										   
//	Pointer to character array and function to display menu
//													  
//	Copyright (C) 1999-2001 NINTENDO Co.,Ltd.		 
//======================================================

#ifndef	__MENUITEM_H__
#define	__MENUITEM_H__

#include <agb.h>
#include "share.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef void (*SampleCallBack)(void);

typedef struct
{
	const char**	title_str;
	const char***	explanation_str_array;
	SampleCallBack	call_back;
} MenuItem;

extern const MenuItem mitem[];

#ifdef __cplusplus
}      /* extern "C" */
#endif

#endif	//  __MENUITEM_H__

//
//
