#pragma warning(disable : 4786)
#ifndef __DATABASE_H__
#define __DATABASE_H__

#include <list>

class DataBase
{
public:
	struct ItemData
	{
		std::string mName;
		int mSize;
		void *mData;
	};

	DataBase();
	~DataBase();

	void Clear(void)
	{
		mItems.clear();
	}

	void Save(void);

	void Load(void);

	void Add(ItemData *item);
	int Find(ItemData *item);

	ItemData *Iterate(bool begin = false);

private:

	std::list<ItemData *> mItems;

	std::list<ItemData *>::iterator mIst,mIen;
};

#endif
