// strat list

#include <Agb.h>
#include "asldefines.h"
#include "particles.h"
//#include "data.h"
#include "main.h"
#include "menu.h"
#include "text.h"
#include "maploader.h"
#include "RawDecompress.h"

// 'strats'
#include "StratList.h"
#include "button.h"
#include "mask.h"
#include "panel.h"
#include "enemynuirama.h"
#include "player.h"
#include "powerups.h"
#include "switch.h"
#include "platform.h"
#include "door.h"
#include "enemybohrok.h"
#include "spikes.h"
#include "camera.h"
#include "enemybat.h"
#include "muakaboss.h"

#include "enemymonkey.h"
#include "enemyspider.h"
#include "popuphelper.h"


// sprites
#include "vplayer.h"
#include "cplayer.h"
#include "epower.h"
#include "switchsprite.h"
#include "platformsprite.h"
#include "bohroksprites.h"
#include "doorsprites.h"
//#include "smashsprites.h"
#include "Shadow.h"
#include "flash.h"
#include "font16.h"
#include "lewahiobjects.h"

// Bosses bits
#include "Muakaarm.h"

// other gfx
#include "newmenu.h"
#include "menubutton.h"
#include "font.h"
#include "healthpanel.h"
#include "particlesprites.h"
#include "islandmap.h"


// sound fx
#include "motor.h"
#include "testloop.h"

// text
#include "strings.h"

// Rainbows
#include "daytonight_rain.h"
#include "SampleManager.h"

#include "rocksandstuff.h"

const Funcp StratList[64] = {  // initialiser
initplayer,
initpowerupchief,
initladder,
initplatform,
initmovingplatform,
initvmovingplatform,
initswitch,
initdoor,
initsmash,
initflamepit,
initairvent,
initspike,
initsand,
initdoorsprite,
initslide,
inittileswapper,
inittileswapsource,
initareaswitch,
initpickupswitch,
initbridge,
initpoweruphealth,
initpowerupepower,
initpoweruplife,
initpickupitem,
initbonusmask,
initpowerupdisc,
initenemybat,
initenemynuirama,
initenemymonkey,
initenemybohrok,
initrock,
initdropper,
initenemyspider,
initswingingrock,
initrestartpoint,
initcameratrigger,
initwaterarea,
initmodeswitch,
initpopup,
initfriends,
initl3remover,
initrainswitch,
initcrumbler,
initmuakoboss,
initrahiboss,
initbaragboss,

};

const u16 StratNumber[64] = { // strat reference number
0,
1,
2,
3,
4,
5,
6,
7,
8,
9,
10,
11,
12,
13,
14,
15,
16,
17,
18,
19,
25,
26,
27,
28,
29,
30,
50,
51,
52,
53,
54,
55,
56,
57,
200,
201,
202,
203,
204,
205,
206,
207,
208,
100,
101,
102,
};